REM Sample SCRIPT to be used as input to sqltxecute.sql or roxecute.sql
REM
REM Optional Binds
REM ~~~~~~~~~~~~~~

VAR b1 NUMBER; 
EXEC :b1 := 10;

REM Optional ALTER SESSION commands
REM ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

ALTER SESSION SET statistics_level = ALL;

REM SQL statement to be executed
REM ~~~~~~~~~~~~~~~~~~~~~~~~~~~~

SELECT /*+ monitor */ /* ^^unique_id */
       s1.channel_id,
       SUM(p.prod_list_price) price
  FROM products p,
       sales s1,
       sales s2
 WHERE s1.cust_id = :b1
   AND s1.prod_id = p.prod_id
   AND s1.time_id = s2.time_id
 GROUP BY
       s1.channel_id;

REM Notes:
REM 1. Script must contain CBO Hint and Token:
REM    /*+ monitor */ /* ^^unique_id */
REM 2. Do not replace ^^unique_id with your own tag.
