CREATE OR REPLACE PACKAGE sqlt$d AUTHID DEFINER AS
/* $Header: 215187.1 sqcpkgd.pks 11.4.4.1 2012/01/02 carlos.sierra $ */

  /*************************************************************************************/

  /* -------------------------
   *
   * public constants
   *
   * ------------------------- */
  TOOL_OWNER       CONSTANT VARCHAR2(32)    := 'SQLTXPLAIN';
  PLAN_FORMAT_A    CONSTANT VARCHAR2(128)   := 'ADVANCED ALLSTATS';
  PLAN_FORMAT_V    CONSTANT VARCHAR2(128)   := 'ADVANCED';
  --PLAN_FORMAT_L    CONSTANT VARCHAR2(128)   := 'TYPICAL ALLSTATS LAST -PREDICATE -NOTE';
  PLAN_FORMAT_L    CONSTANT VARCHAR2(128)   := 'ADVANCED ALLSTATS LAST';

  /*************************************************************************************/

  /* -------------------------
   *
   * static variables
   *
   * ------------------------- */
  s_insert_list_pq_tqstat VARCHAR2(32767);
  s_select_list_pq_tqstat VARCHAR2(32767);

  /*************************************************************************************/

  /* -------------------------
   *
   * public apis
   *
   * ------------------------- */

  PROCEDURE capture_sqltext (
    p_statement_id         IN NUMBER,
    p_string               IN VARCHAR2,
    p_sql_id_or_hash_value IN VARCHAR2,
    p_child_number         IN VARCHAR2 DEFAULT NULL,
    p_input_filename       IN VARCHAR2 DEFAULT NULL );

  PROCEDURE capture_xplain_plan_hash_value (
    p_statement_id IN NUMBER,
    p_string       IN VARCHAR2 );

  PROCEDURE collect_gv$parameter_cbo (p_statement_id IN NUMBER);

  PROCEDURE collect_gv$pq_tqstat (
    p_statement_id IN NUMBER,
    p_statid       IN VARCHAR2,
    p_insert_list  IN VARCHAR2,
    p_select_list  IN VARCHAR2 );

  PROCEDURE collect_perf_stats_begin (
    p_statement_id IN NUMBER,
    p_statid       IN VARCHAR2,
    p_sid          IN NUMBER );

  PROCEDURE collect_perf_stats_end (
    p_statement_id IN NUMBER,
    p_statid       IN VARCHAR2,
    p_sid          IN NUMBER );

  PROCEDURE collect_perf_stats_post (
    p_statement_id IN NUMBER,
    p_statid       IN VARCHAR2 );

  PROCEDURE collect_perf_stats_pre;

  PROCEDURE collect_px_perf_stats (p_statement_id IN NUMBER);

  PROCEDURE diagnostics_data_collection_1 (
    p_statement_id        IN NUMBER,
    p_out_file_identifier IN VARCHAR2 DEFAULT NULL );

  PROCEDURE diagnostics_data_collection_2 (
    p_statement_id IN NUMBER,
    p_group_id     IN NUMBER DEFAULT NULL );

  PROCEDURE get_list_of_columns (
    p_source_owner      IN  VARCHAR2 DEFAULT 'SYS',
    p_source_table      IN  VARCHAR2,
    p_source_alias      IN  VARCHAR2 DEFAULT NULL,
    p_destination_owner IN  VARCHAR2 DEFAULT TOOL_OWNER,
    p_destination_table IN  VARCHAR2,
    x_insert_list       OUT VARCHAR2,
    x_select_list       OUT VARCHAR2 );

  PROCEDURE list_of_indexes (p_statement_id IN NUMBER);

  FUNCTION max_plan_elapsed_time_secs (p_statement_id IN NUMBER)
  RETURN NUMBER;

  PROCEDURE search_sql_by_sqltext (p_statement_id IN NUMBER);

  /*************************************************************************************/

END sqlt$d;
/

SET TERM ON;
SHOW ERRORS;
